% $Id: OzParserTest.oz,v 1.3 2006/09/26 09:00:56 leavens Exp leavens $
%
% This file is meant to be compiled as an expression,
% not fed as a statement.  Use
%
%    ozc -c OzParserTest.oz
%
% and then run it as in:
%
%    ozengine OzParserTest.ozf small_pgm.oz
%
% AUTHOR: Chris Cornelison and Gary T. Leavens
%         based on section 4.5.1 in "The Mozart Compiler" by Leif Kornstaedt.

functor $
import
   Application(getArgs exit)
   Inspector(inspect)
   System(printInfo)
   OzParserRunner(narratorAndListener parseFile)
define
   AST NarratorO ListenerO
in
   try
      case {Application.getArgs plain} of [FileName] then
         {OzParserRunner.narratorAndListener NarratorO ListenerO}
         AST = {OzParserRunner.parseFile FileName NarratorO}
         % Apparently parsing is lazy, so have to inspect first,
         % before one can see errors.
         {Inspector.inspect AST}

         if {ListenerO hasErrors($)}
         then {System.printInfo {ListenerO getVS($)}}
         end
      end
   finally {ListenerO close()}
   end
end
